<?php
Rhaco::import("database.data.TableObjectBase");
Rhaco::import("database.data.Column");
Rhaco::import("database.data.Table");
Rhaco::import("database.data.Criteria");
Rhaco::import("lang.StringUtil");

Rhaco::import("lang.DateUtil");
Rhaco::importLibrary("data.verify.UserLoginVerify");
Rhaco::importLibrary("data.UserDetail");
Rhaco::importLibrary("data.Memory");
Rhaco::importLibrary("data.Bookmark");
class UserLoginTable extends TableObjectBase{
	var $id;
	var $login;
	var $password;
	var $code;

	function UserLoginTable(
		$id=null
	){
		$this->id = 0;
		$this->login = null;
		$this->password = null;
		$this->code = null;
		$this->setId($id);
	}

	function setId($value){
		$this->id = sprintf("%d",StringUtil::convertZenhan($value));
	}
	function getId(){
		return $this->id;
	}
	function setLogin($value){
		$this->login = $value;
	}
	function getLogin(){
		return $this->login;
	}
	function setPassword($value){
		$this->password = $value;
	}
	function getPassword(){
		return $this->password;
	}
	function setCode($value){
		$this->code = $value;
	}
	function getCode(){
		return $this->code;
	}
	
	function columnId(){
		return new Column(new Table(Rhaco::define("DATABASE_goesby_PREFIX")."USER_LOGIN","USER_LOGIN"),"ID","Id","SERIAL");
	}
	function columnLogin(){
		return new Column(new Table(Rhaco::define("DATABASE_goesby_PREFIX")."USER_LOGIN","USER_LOGIN"),"LOGIN","Login","STRING");
	}
	function columnPassword(){
		return new Column(new Table(Rhaco::define("DATABASE_goesby_PREFIX")."USER_LOGIN","USER_LOGIN"),"PASSWORD","Password","STRING");
	}
	function columnCode(){
		return new Column(new Table(Rhaco::define("DATABASE_goesby_PREFIX")."USER_LOGIN","USER_LOGIN"),"CODE","Code","STRING");
	}

	function __columns(){
		return array(
				$this->columnId()
				,$this->columnLogin()
				,$this->columnPassword()
				,$this->columnCode()
				);
	}
	function __primaryKey(){
		return array(	
				$this->columnId()
				);
	}
	function dependColumnId(){
		$list	= array();
	
		$criteria = new Criteria();
		$criteria->add(UserDetail::columnUserId(),$this->getId());
		$list[] = array(new UserDetail(),$criteria);
	
		$criteria = new Criteria();
		$criteria->add(Memory::columnUserId(),$this->getId());
		$list[] = array(new Memory(),$criteria);
	
		$criteria = new Criteria();
		$criteria->add(Bookmark::columnUserId(),$this->getId());
		$list[] = array(new Bookmark(),$criteria);
		
		return $list;
	}
	function related($criteria=null){
		if(!preg_match("/Criteria/i",get_class($criteria))){		
			$criteria = new Criteria();
		}
		
		return $criteria;
	}
	function __verify(){
		$verify = new UserLoginVerify();
		return $verify->verify($this);
	}
}
?>